# coding=utf-8
"""
This file is part of GeoRemindMe.

GeoRemindMe is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GeoRemindMe is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GeoRemindMe.  If not, see <http://www.gnu.org/licenses/>.


"""
from google.appengine.ext import db

class AccessTokenHelper(object):
    def get_token_key(self, key, provider):
        return AccessToken.all().filter('provider =', provider).filter('token_key =', key).get()
    
    def get_user_token(self, user, provider):
        return AccessToken.all().filter('provider =', provider).filter('user =', user.key()).get()

class AccessToken(db.Model):
    token_key = db.StringProperty(required=False)
    token_secret = db.TextProperty(required=False)
    date = db.DateTimeProperty(auto_now=True, indexed=False)
    verifier = db.TextProperty(required=False)
    authorized_access = db.BooleanProperty(required=False, indexed=False, default=False)
    provider = db.StringProperty(required=True)
    from georemindme.models import User
    user = db.ReferenceProperty(User, required=True)
    
    objects = AccessTokenHelper()
