from OAuthSignature import SignatureBase
import urllib
def escape(s):
    """Escape a URL including any /."""
    return urllib.quote(s, safe='~')

class HMAC_SHA1(SignatureBase):
    def __init__(self):
        self.signature_method='HMAC-SHA1'
    
    def build_signature(self, oauth_request, oauth_consumer, token):
        signature = (
                     oauth_request.normalize_http_method(),
                     oauth_request.normalize_http_url(),
                     oauth_request.normalize_parameters(),
                     )
        
        key = '%s&' % (oauth_consumer.secret)
        if token:
            key += token.secret
            
        raw = '&'.join(signature)
        
        import hmac
        import hashlib
        hashed = hmac.new(key, raw, hashlib.sha1).digest().encode("base64").strip()
        return hashed
                
        